<template>
  <a-modal
    title="发票号码明细"
    v-model="invoiceNumModVis"
    :confirmLoading="confirmLoading"
    width="86%"
    :footer="null"
  >
    <!-- tabel 加载 -->
    <a-spin :spinning="confirmLoading">
      <!-- 查询  -->
      <div class="table-page-search-wrapper">
        <a-form layout="inline" @keyup.enter.native="searchQuery">
          <a-row :gutter="24">
            <a-col :md="6" :sm="8">
              <a-form-item label="物料">
                <a-input placeholder="请输入物料" v-model="queryParam.cinvName"></a-input>
              </a-form-item>
            </a-col>

            <a-col :md="6" :sm="8">
              <span style="float: left;overflow: hidden;" class="table-page-search-submitButtons">
                <a-button type="primary" @click="searchQuery" icon="search">查询</a-button>
                <a-button type="primary" icon="download" @click="exportExcel" style="margin-left: 8px">导出</a-button>
                <JsonExcel
                  :fetch="getExportDataList"
                  :fields="exportFields"
                  :header="exportTitle"
                  name="发票号码明细.xls"
                  style="display:none"
                >
                  <!-- 上面可以自定义自己的样式，还可以引用其他组件button -->
                  <a-button type="primary" icon="download" ref="realExportExcel">导出</a-button>
                  
                </JsonExcel>
                <a-button type="primary" @click="searchReset" icon="reload" style="margin-left: 8px">重置</a-button>
                <!-- <a @click="handleToggleSearch" style="margin-left: 8px">
                  {{ toggleSearchStatus ? '收起' : '展开' }}
                  <a-icon :type="toggleSearchStatus ? 'up' : 'down'" />
                </a> -->
              </span>
            </a-col>
          </a-row>
        </a-form>
      </div>

      <!-- table -->
      <div>
        <a-table
          bordered
          :loading="loading"
          :columns="invoiceNumColumns"
          :data-source="invoiceNumData"
          :pagination="false"
          :scroll="{ y: 500 }"
          :footer="showTotal"
        >
        </a-table>
        <!-- 导出 打印 返回  -->
        <a-row style="marginTop:20px;">
          <a-col :md="24" :sm="12">
            <span style="float: right;" class="table-operator">
              <!-- <a-button type="primary" icon="download" @click="handleExportXls('采购数量')">导出</a-button>
              <a-button type="primary" @click="print" icon="printer" style="margin:0 10px;">打印</a-button> -->
              <a-button type="primary" @click="backFabricLossTable" icon="rollback">关闭</a-button>
            </span>
          </a-col>
        </a-row>
      </div>
    </a-spin>
  </a-modal>
</template>

<script>
import { JeecgListMixin } from '@/mixins/JeecgListMixin'
import JEllipsis from '@/components/jeecg/JEllipsis'
import JsonExcel from 'vue-json-excel'
export default {
  name: 'InvoiceNumModal', // 发票号明细 弹框
  mixins: [JeecgListMixin],
  components: { JEllipsis,JsonExcel },
  data() {
    return {
      exportTitle:"发票号码明细",
      // 表头
      invoiceNumColumns: [
        {
          title: '序号',
          width:80,
           customRender: (text, record, index) => {
            if (record.cinvName == "合计")
              return "";
            else
              return index + 1;
           }
        },
        {
          title: '物料',
          dataIndex: 'cinvName',
          width: 400,
          key: '',
          className: 'replacecolor'
        },
        {
          title: '数量',
          dataIndex: 'iquantity',
          width: 120,
          key: '',
          className: 'replacecolor'
        },
        {
          title: '开票单价',
          dataIndex: 'iprice',
          width: 120,
          key: '',
          className: 'replacecolor'
        },
        {
          title: '合计金额',
          dataIndex: 'inatSum',
          width: 120,
          key: '',
          className: 'replacecolor'
        }
      ],
      invoiceNumData: [],
      allDataList:[],

      loading: false, // 表格加载
      // orderDataform: this.$form.createForm(this),
      confirmLoading: false,
      invoiceNumModVis: false,
      // 查询条件
      queryParam: {
        material: '', // 物料
        invoicingPrice: '' // 开票单价
      }
    }
  },
  // 接收父组件 方法
  props: {
    father: {
      type: Function,
      default: null
    }
  },
  created() {},
  computed: {
    // 合计展示
    totalDataSource(){
      // 开票成本-衬衣 合计
      var item = {
        "cinvName":"合计"
      };
      var iquantity = 0,inatSum = 0;
      for (let row of this.invoiceNumData){
        iquantity += row.iquantity*1;
        inatSum += row.inatSum*1;
      }
      
      item.iquantity= parseFloat(iquantity.toFixed(4));
      item.inatSum= parseFloat(inatSum.toFixed(2));
      return [item];

    },
    // 获取导出json定义
    exportFields(){
      var ret = {};
      this.invoiceNumColumns.forEach((record,index)=>{
        if (record.title != "序号"){
          if (record.title != "入库单号")
            ret[record.title] = record.dataIndex;
          else
            ret[record.title] = record.dataIndex+"_ex";
        }

      });
      return ret;
    }
  },
  methods: {
    // 第一行 导出
    handleExportXls() {},
    // 打印
    print() {},
    // 返回
    backFabricLossTable() {
      console.log('返回到面料损耗表')
      // this.$router.push('fabricLoss-table')
      // this.invoiceNumModVis = false
      this.close()
    },
    // 弹框查询按钮
    searchQuery() {
      this.invoiceNumData = this.allDataList.filter(e=>
        (this.queryParam.cinvName == null || e.cinvName.toLowerCase().indexOf(this.queryParam.cinvName.toLowerCase())>-1)
      );
    },
    // 重置
    searchReset() {
      this.queryParam = {}
      // this.getShipmentList()
    },
    close() {
      this.$emit('close')
      this.invoiceNumModVis = false
    },
    showTotal(data) {
      return (
        <a-table
          rowKey={Math.random}
          bordered={false}
          pagination={false}
          columns={this.invoiceNumColumns}
          dataSource={this.totalDataSource || []}
          showHeader={false}
        ></a-table>
      )
    },
     // 导出excel
    exportExcel(){
      this.$refs.realExportExcel.$el.click();
    },
    // 生成导出数据
    getExportDataList(){
      this.invoiceNumData.forEach((item,index)=>{item["ccode_ex"]="&nbsp;"+item["ccode"]});
      return this.invoiceNumData;
    }
  }
}
</script>
<style lang="less" scoped>
@import '~@assets/less/common.less';
@import '~@assets/less/overwriter.less';
/deep/ .ant-table-thead > tr > th {
  text-align: center;
  // font-weight: 700;
}

/deep/ .ant-table-tbody {
  text-align: center;
}

// /deep/ th.replacecolor {
//   background-color: #ccc;
// }
</style>
